Module Windows_Menu_mod


  !----------------------------------------------------
  ! The main windows output
  !----------------------------------------------------
  Use Dflib
  Implicit None
  
Contains
  !-----------------------------------------------------------------------
  Subroutine Windows_Menu
    
    Integer                   ::  i
    Type (windowconfig)       ::  wc
    Logical(4)                ::  status
    Type(qwinfo)              ::  winfo
    
    ! Maximize frame window
    winfo%TYPE = QWIN$MAX
    status = SETWSIZEQQ(QWIN$FRAMEWINDOW, winfo)
    
    ! No exit box
    i = SETEXITQQ(QWIN$EXITPERSIST)
    
    ! The about box
    i = ABOUTBOXQQ ('GranFilm-v1.0 : SPHERE 1998-2001\r&
		 \r&
         Rmi Lazzari\r&
         CEA-Grenoble\r&
         DSM/DRFMC/SP2M/IRS\r&
		 17 rue des Martyrs\r&
		 38000 Grenoble\r&
		 FRANCE\r&
         Tel: (33)-4-38-78-57-61\r&
         Fax: (33)-4-38-78-51-38\r&
         lazzari@drfmc.ceng.cea.fr\r&
		 \r&
		 Ingve Simonsen\r&
         NORDITA\r&
         Blegdamsvej 17\r&
         DK-2100 Copenhagen\r&                 
         DENMARK\r&                            
         Tel: +45 35 32 55 06\r&
         Fax: +45 35 38 91 57\r&
         ingves@nordita.dk'C)
    
    
    ! Open the main output file
    Open(unit=6,file='CONOUT$')
    wc%numxpixels  = 500     
    wc%numypixels  = 800     
    wc%numtextcols = -1
    wc%numtextrows = -1     
    wc%numcolors   = -1     
    wc%title       = "Main Window Output"C
    wc%fontsize    = #0008000C
    status         = SETWINDOWCONFIG(wc)
    if(.not.status)  status = SETWINDOWCONFIG(wc)
    i = SETBKCOLOR (7) ! bright white
    Call CLEARSCREEN($GCLEARSCREEN) 
    i = SETTEXTCOLOR (0) 
    ! Maximize child window
    winfo%TYPE = QWIN$SET
    winfo%h = 40
    winfo%w = 100
    status = SETWSIZEQQ(6, winfo)
    
  End Subroutine Windows_Menu
  
End Module Windows_Menu_mod


!-----------------------------------------------------------------------

Logical(4) Function InitialSettings
  
  ! This routine is called automatically when the program begins.  It sets
  ! up the menu structure for the program, and connects "callback" routines
  ! with each menu item.
  
  Use Dflib
  Logical(4)  ::  l4
  
  l4 = APPENDMENUQQ(1, $MENUENABLED,   '&File'C,NUL)
  l4 = APPENDMENUQQ(1, $MENUENABLED,   '&Save'C,WINSAVE)
  l4 = APPENDMENUQQ(1, $MENUENABLED,   '&Pause Ctrl S'C,WINSTATE)
  l4 = APPENDMENUQQ(1, $MENUENABLED,   '&Exit Crtl C'C,WINEXIT)
  
  l4 = APPENDMENUQQ(2, $MENUENABLED,   '&Edit'C,NUL)
  l4 = APPENDMENUQQ(2, $MENUENABLED,   'Select &Text'C,WINSELECTTEXT)
  l4 = APPENDMENUQQ(2, $MENUENABLED,   'Select &Graph'C,WINSELECTGRAPHICS)
  l4 = APPENDMENUQQ(2, $MENUENABLED,   'Select &All'C,WINSELECTALL)
  l4 = APPENDMENUQQ(2, $MENUENABLED,   '&Copy Ctrl Ins'C,WINCOPY)
  l4 = APPENDMENUQQ(2, $MENUENABLED,   '&Paste'C,WINPASTE)
  l4 = APPENDMENUQQ(2, $MENUENABLED,   'C&learPaste'C,WINCLEARPASTE)
  
  
  l4 = APPENDMENUQQ(3, $MENUENABLED,  '&Windows'C,NUL)
  l4 = APPENDMENUQQ(3, $MENUENABLED,  '&Size to Fit'C,WINSIZETOFIT)
  l4 = APPENDMENUQQ(3, $MENUENABLED,  '&Full Screen Alt+Enter'C,WINFULLSCREEN )
  l4 = APPENDMENUQQ(3, $MENUENABLED,  '&Cascade'C,WINCASCADE)
  l4 = APPENDMENUQQ(3, $MENUENABLED,  '&Tile'C,	WINTILE)
  l4 = APPENDMENUQQ(3, $MENUENABLED,  'Arange &Icons'C,WINARRANGE)
  l4 = APPENDMENUQQ(3, $MENUENABLED,  '&Status bar'C,WINSTATUS)
  l4 = SETWINDOWMENUQQ(3)
  
  l4 = APPENDMENUQQ(4, $MENUENABLED,   '&Help'C,NUL)
  l4 = APPENDMENUQQ(4, $MENUENABLED,   '&About'C,WINABOUT)
  
  InitialSettings = l4
  
  return
  
End Function InitialSettings








