
!--------------------------------------------------------------------------------
!              SPHEROID part of GranFilm v 1.0
!
!   (C) Ingve Simonsen and Remi Lazzari, 1998-2001	
!
!   $Id: write_mod.f90,v 1.1 2001/07/29 12:49:28 ingves Exp ingves $
!---------------------------------------------------------------------------------



Module Write_mod

  Use Global_definitions
  Use Graphics

Contains

!---------------------------------------------------------------

  Subroutine write2screen2file(Fresnel_coeff,param)
    
    Use Initialize_mod, Only     : locate 
    Implicit None     
    Type(parameters)         :: param
    Real(wp)                 :: Fresnel_coeff(param%Nenergy),wavelength
    Real(wp)                 :: extremal(2)
    Integer                  :: Iextremal(2),ienergy,npts,start
    Real(wp),Allocatable     :: Eexp(:),Drexp(:),Fresnel_coeffexp(:)
    Real(wp)                 :: slope
    Character(len=25)        :: filename
    Logical                  :: exi
    Character(len=40)        :: header
    Real(wp)                 :: chi2
    Real(wp)                 :: Eminexp(1),Minexp,Emaxexp(1),Maxexp
    Integer                  :: itmp(1)
    
    
    !**************************************
    !*** Write results on screen  
    !**************************************    
    
    ! Find max/min
    extremal(1) = maxval(Fresnel_coeff)
    extremal(2) = minval(Fresnel_coeff)
    Iextremal(1:1) = maxloc(Fresnel_coeff)
    Iextremal(2:2) = minloc(Fresnel_coeff)
    
    
    ! Write out the results
    write(*,*)  
    write(*,*)  '----------------------------------------------------'
    write(*,*)  '----------- Calculated parameters ------------------' 
    write(*,*)  '----------------------------------------------------'
    write(*,*)
    If(param%out=='DR'.or.param%out=='DT') then
       write(*,'(a,f8.4,a,f10.4)') ' Max  at :   E = ', param%energy(Iextremal(1)), '   value = ', extremal(1)
       write(*,'(a,f8.4,a,f10.4)') ' Min  at :   E = ', param%energy(Iextremal(2)), '   value = ', extremal(2)
    Endif
    write(*,*)  
    ! Mean thickness/shape ratio
    write(*,'(a,f8.4)')  ' Shape ratio               : ',  param%SR
    write(*,'(a,f8.4)')  ' Mean film thickness (nm)  : ',  param%mean_thickness 
    write(*,*)  
    
    !**************************************
    !*** Write parameter-file  as well 
    !**************************************     

    ! Opens the output-file
    Open(unit=10,file=Trim(Adjustl(param%outfilename))//'.dat')  
    write(10,'(a)') '# HEADER '
    write(10,'(a)',advance='no') '# Type of model             : ' ;  write(10,*) param%geometry
    write(10,'(a)',advance='no') '# Calculation of            : ' ;  write(10,*) param%out
    write(10,'(a)',advance='no') '# Energy min                : ' ;  write(10,*) param%energy_min
    write(10,'(a)',advance='no') '# Energy max                : ' ;  write(10,*) param%energy_max
    write(10,'(a)',advance='no') '# Incident angle (rad)      : ' ;  write(10,*) param%theta0
    write(10,'(a)',advance='no') '# Polarisation              : ' ;  write(10,*) param%polarization
    write(10,'(a)',advance='no') '# Film material             : ' ;  write(10,*) param%island
    write(10,'(a)',advance='no') '# Coating material          : ' ;  write(10,*) param%coating
    write(10,'(a)',advance='no') '# Coating layer thichkness  : ' ;  write(10,*) param%thickness
    write(10,'(a)',advance='no') '# Geometry                  : ' ;  write(10,*) param%island_type
    write(10,'(a)',advance='no') '# Substrate material        : ' ;  write(10,*) param%substrate
    write(10,'(a)',advance='no') '# Fresnel formulae          : ' ;  write(10,*) param%fresnel
    write(10,'(a)',advance='no') '# Finite size effects       : ' ;  write(10,*) param%mean_free_path
    write(10,'(a)',advance='no') '# Surface effects           : ' ;  write(10,*) param%surface_effects
    write(10,'(a)',advance='no') '# Interactions              : ' ;  write(10,*) param%interaction
    write(10,'(a)',advance='no') '# Temperature (K)           : ' ;  write(10,*) param%temperature
    write(10,'(a)',advance='no') '# Parallel radius (nm)      : ' ;  write(10,*) param%R_par
    write(10,'(a)',advance='no') '# Perpendicular radius (nm) : ' ;  write(10,*) param%R_per
    write(10,'(a)',advance='no') '# Truncation parameter      : ' ;  write(10,*) param%tr
    write(10,'(a)',advance='no') '# Flattening parameter(xi0) : ' ;  write(10,*) param%xi0
    write(10,'(a)',advance='no') '# Foci distance (nm)        : ' ;  write(10,*) param%a
    write(10,'(a)',advance='no') '# Coverage                  : ' ;  write(10,*) param%coverage
    write(10,'(a)',advance='no') '# Network                   : ' ;  write(10,*) param%network
    write(10,'(a)',advance='no') '# Lattice constant          : ' ;  write(10,*) param%lattice_const
    write(10,'(a)',advance='no') '# # multipoles              : ' ;  write(10,*) param%Mpole_order
    write(10,'(a)',advance='no') '# Shape ratio               : ' ;  write(10,*) param%SR
    write(10,'(a)',advance='no') '# Density                   : ' ;  write(10,*) param%density
    write(10,'(a)',advance='no') '# Mean thickness (nm)       : ' ;  write(10,*) param%mean_thickness
    write(10,'(a)',advance='no') '# Max  at :   E = ' ;  write(10,*) param%energy(Iextremal(1)), '   value = ', extremal(1)
    write(10,'(a)',advance='no') '# Min  at :   E = ' ;  write(10,*) param%energy(Iextremal(2)), '   value = ', extremal(2)
    write(10,'(a)')  '#' 
    write(10,'(a)') '# FORMAT:  Energy (eV)         Value          Wavelength (nm)'
    write(10,'(a)')  '#'     
    
    Do ienergy=1,param%Nenergy
       wavelength = 2*pi*param%hbar*param%c/param%energy(ienergy)
       Write(10,'(3E20.8)') param%energy(ienergy), Fresnel_coeff(ienergy), wavelength
    Enddo
    Close(10)
    
    ! Graphical result
    Select Case(param%out)
    Case('DR')
       header = 'Differential Reflectivity'
    Case('DT')
       header = 'Differential Transmittance'
    Case('R')
       header = 'Coefficient of reflection'
    Case('T')
       header = 'Coefficient of transmision'
    Case('A')
       header = 'Coefficient of absorption'
    Case Default
       Write(6,*) 'Error in write2screen2file for param%out'
       Pause
       stop
    End Select
    
    ! Comparison with experiment
    If(param%compa) Then
       
       filename = Trim(Adjustl(param%expfilename))//'.dat'
       Inquire(file=filename,exist=exi)
       If(.not.exi) then
          Write(*,*) 'ERROR (write2screen2file) : File = ',filename,' non existing'
          Pause
          Return
       Endif
       Open(20,file=filename)
       npts = 1024
10     Allocate(Eexp(npts),DRexp(npts),Fresnel_coeffexp(param%Nenergy))
       Do ienergy=1,5
          Read(20,*)
       Enddo
       Do ienergy = 1,npts
          Read(20,*) Eexp(ienergy),DRexp(ienergy)
       Enddo
       Close(20)
       ! Does the interpolation
       Do ienergy=1,param%Nenergy
          start=locate(Real(Eexp(:),sp),Real(param%energy(ienergy),sp))
          If ((start==0).Or.(start==npts)) Then
             Write(*,*) 'ERROR (write2file2screen) : Energy not in range '
             Pause
             stop
          End If
          ! Linear interpolation
          slope = (DRexp(start+1)-DRexp(start))/(Eexp(start+1)-Eexp(start))
          Fresnel_coeffexp(ienergy) = DRexp(start) + slope*(param%energy(ienergy)-Eexp(start))
       Enddo
       ! Get the peak positions and write the result for the peak positions
       Minexp = Minval(DRexp)
       Maxexp = Maxval(DRexp)
       itmp = Minloc(DRexp)
       Eminexp = Eexp(itmp(1))
       itmp = Maxloc(DRexp)
       Emaxexp = Eexp(itmp(1))
       Deallocate(Eexp,DRexp)
       write(*,*)  
       write(*,*)  '------------------------------------------------------'
       write(*,*)  '------------ Experimental parameters -----------------' 
       write(*,*)  '------------------------------------------------------'
       write(*,*)
       write(*,'(a,f8.4,a,f10.4)') ' Max  at :   E = ', Emaxexp, '   value = ', Maxexp
       write(*,'(a,f8.4,a,f10.4)') ' Min  at :   E = ', Eminexp, '   value = ', Minexp
       write(*,*)
       ! Get the chi2 value
       chi2 = Sum((Fresnel_coeff(:)-Fresnel_coeffexp(:))**2)
       chi2 = Sqrt(chi2/param%Nenergy)
       write(*,'(a,f8.4)') '  Reliance factor chi2 :',chi2
       write(*,*)
       ! Plot
       Call plot(real(param%energy,sp),real(Fresnel_coeff,sp),yr2=real(Fresnel_coeffexp,sp), &
            xlabel='Energy(eV)',ylabel=param%out,title=header, &
            flag=.false.)
       Deallocate(Fresnel_coeffexp)
       
       
    Else
       
       ! Theoritical result alone
       Call plot(real(param%energy,sp),real(Fresnel_coeff,sp), &
            xlabel='Energy(eV)',ylabel=param%out,title=header, &
            flag=.false.)
    EndIf
    
    
    Return
  End Subroutine write2screen2file
  
  
End Module Write_mod
